package com.liang.service;

import com.liang.entity.BaseProjectbudget;
import com.liang.entity.PrjSubtopic;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;

import java.util.List;
import java.util.Map;

/**
 * (PrjSubtopic)表服务接口
 *
 * @author makejava
 * @since 2023-03-20 16:25:07
 */
public interface PrjSubtopicService {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    PrjSubtopic queryById(Integer id);

    /**
     * 分页查询
     *
     * @param prjSubtopic 筛选条件
     * @param pageRequest 分页对象
     * @return 查询结果
     */
    Page<PrjSubtopic> queryByPage(PrjSubtopic prjSubtopic, PageRequest pageRequest);

    /**
     * 新增数据
     *
     * @param prjSubtopic 实例对象
     * @return 实例对象
     */
    int insert(PrjSubtopic prjSubtopic);

    /**
     * 修改数据
     *
     * @param prjSubtopic 实例对象
     * @return 实例对象
     */
    int update(PrjSubtopic prjSubtopic);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 是否成功
     */
    boolean deleteById(Integer id);

    /**
     * 获取子课题列表
     *
     * @return
     */
    List<PrjSubtopic> getSubtopicList(Integer xm);

    /**
     * 批量删除子课题
     *
     * @param idList
     * @return
     */
    int batchDelete(List<Integer> idList);

    /**
     * 通过项目删除数据
     *
     * @param xm
     * @return
     */
    int deleteByXm(Integer xm);

    /**
     * 批量删除子课题
     *
     * @param xmList
     * @return
     */
    int batchDeleteByXm(List<Integer> xmList);

    /**
     * 根据任务书id查询任务书的日期信息
     *
     * @param id 项目id
     * @return
     */
    List<Map<String, Object>> queryProjectDate(int id);
}
